#!/usr/bin/env python
# coding: utf-8

# In[1]:


import tkinter
import random

ROWS = 25
COLS = 25
TILE_SIZE = 25

WINDOW_WIDTH = TILE_SIZE * COLS
WINDOW_HEIGHT = TILE_SIZE * ROWS


class Tile:
    def _init_(self, x, y):
        self.x = x
        self.y = y


# game window
window = tkinter.Tk()
window.title("Snake")
window.resizable(False, False)

canvas = tkinter.Canvas(window, bg="black", width=WINDOW_WIDTH, height=WINDOW_HEIGHT, borderwidth=0,
                        highlightthickness=0)
canvas.pack()
window.update()

# center the window
window_width = window.winfo_width()
window_height = window.winfo_height()
screen_width = window.winfo_screenwidth()
screen_height = window.winfo_screenheight()

window_x = int((screen_width / 2) - (window_width / 2))
window_y = int((screen_height / 2) - (window_height / 2))

# format "(w)x(h)+(x)+(y)"
window.geometry(f"{window_width}x{window_height}+{window_x}+{window_y}")


# initialize game
def reset_game():
    global snake_head, food_tile, velocity_x, velocity_y, snake_body, game_over, score, game_speed
    snake_head = Tile(TILE_SIZE * 5, TILE_SIZE * 5)  # single tile, snake's head
    food_tile = Tile(TILE_SIZE * 10, TILE_SIZE * 10)
    velocity_x = 0
    velocity_y = 0
    snake_body = []  # multiple snake tiles
    game_over = False
    score = 0
    game_speed = 100  # initial game speed (delay in ms)


reset_game()


# game loop
def on_key_release(event):
    global velocity_x, velocity_y, game_over
    if game_over:
        if event.keysym == "r" or event.keysym == "R":  # Reset game on 'R' key press
            reset_game()
        return

    if event.keysym == "Up" and velocity_y != 1:
        velocity_x = 0
        velocity_y = -1

    elif event.keysym == "Down" and velocity_y != -1:
        velocity_x = 0
        velocity_y = 1

    elif event.keysym == "Left" and velocity_x != 1:
        velocity_x = -1
        velocity_y = 0

    elif event.keysym == "Right" and velocity_x != -1:
        velocity_x = 1
        velocity_y = 0


def update_snake_position():
    global snake_head, food_tile, snake_body, game_over, score, game_speed
    if game_over:
        return

    if snake_head.x < 0 or snake_head.x >= WINDOW_WIDTH or snake_head.y < 0 or snake_head.y >= WINDOW_HEIGHT:
        game_over = True
        return

    for tile in snake_body:
        if snake_head.x == tile.x and snake_head.y == tile.y:
            game_over = True
            return

    # collision with food
    if snake_head.x == food_tile.x and snake_head.y == food_tile.y:
        snake_body.append(Tile(food_tile.x, food_tile.y))
        food_tile.x = random.randint(0, COLS - 1) * TILE_SIZE
        food_tile.y = random.randint(0, ROWS - 1) * TILE_SIZE
        score += 1
        game_speed = max(50, game_speed - 5)  # increase speed (decrease delay) with a lower bound

    # update snake body
    for i in range(len(snake_body) -     1, -1, -1):
        tile = snake_body[i]
        if i == 0:
            tile.x = snake_head.x
            tile.y = snake_head.y
        else:
            prev_tile = snake_body[i - 1]
            tile.x = prev_tile.x
            tile.y = prev_tile.y

    snake_head.x += velocity_x * TILE_SIZE
    snake_head.y += velocity_y * TILE_SIZE


def render_game():
    global snake_head, food_tile, snake_body, game_over, score, game_speed
    update_snake_position()

    canvas.delete("all")

    # draw food
    canvas.create_rectangle(food_tile.x, food_tile.y, food_tile.x + TILE_SIZE, food_tile.y + TILE_SIZE, fill='red')

    # draw snake
    canvas.create_rectangle(snake_head.x, snake_head.y, snake_head.x + TILE_SIZE, snake_head.y + TILE_SIZE,
                            fill='lime green')

    for tile in snake_body:
        canvas.create_rectangle(tile.x, tile.y, tile.x + TILE_SIZE, tile.y + TILE_SIZE, fill='lime green')

    if game_over:
        canvas.create_text(WINDOW_WIDTH / 2, WINDOW_HEIGHT / 2, font="Arial 20",
                           text=f"Game Over: {score}\nPress 'R' to Restart", fill="white")
    else:
        canvas.create_text(30, 20, font="Arial 10", text=f"Score: {score}", fill="white")

    window.after(game_speed, render_game)  # call render_game again with adjusted speed


render_game()
window.bind("<KeyRelease>", on_key_release)  # when you press on any key and then let go
window.mainloop()  # used for listening to window events like key presses


# In[ ]:





# In[ ]:




